// Demonstrate FileReader.
// source: http://www.java-samples.com/showtutorial.php?tutorialid=392
// purpose: This program demonstrates how to use the FileReader class to
//          set up an input file.

import java.io.*;

class FileReaderDemo {

    public static void main(String args[]) throws Exception {
        FileReader fr = new FileReader("FileReaderDemo.java");
        BufferedReader br = new BufferedReader(fr);
/* http://download.oracle.com/javase/6/docs/api/java/io/BufferedReader.html
 * Without buffering, each invocation of read() or readLine() could cause bytes to be read from the file,
 * converted into characters, and then returned, which can be very inefficient.
 */
        String s;
        while ((s = br.readLine()) != null) {
            System.out.println(s);
        }
        fr.close();
    }
} // class FileReaderDemo
